// Generated by CoffeeScript 1.12.7
(function() {
  var INTERVAL_TIME, LyncManager, _checkLync, autoCheck, autoCheckTimeout, debug, stopAutoCheck;

  LyncManager = require('./lync-manager');

  debug = require('debug')('meshblu-connector-skype:lync-launcher');

  INTERVAL_TIME = 20000;

  autoCheckTimeout = null;

  autoCheck = (function(_this) {
    return function() {
      if (autoCheckTimeout != null) {
        clearTimeout(autoCheckTimeout);
      }
      return _checkLync(function(error) {
        if (error != null) {
          console.error('LyncLauncher->autoCheck', {
            error: error
          });
        }
        return autoCheckTimeout = setTimeout(autoCheck, INTERVAL_TIME);
      });
    };
  })(this);

  stopAutoCheck = (function(_this) {
    return function() {
      debug('stopAuthCheck');
      return clearTimeout(autoCheckTimeout);
    };
  })(this);

  _checkLync = (function(_this) {
    return function(callback) {
      var lyncManager;
      debug('checkLync');
      lyncManager = new LyncManager({
        dirname: process.env.MESHBLU_CONNECTOR_EDGE_ASSETS_DIR
      });
      return lyncManager.getState(null, function(error, state) {
        debug('lyncManager.getState', JSON.stringify({
          error: error,
          state: state
        }, null, 2));
        if (error != null) {
          return callback(error);
        }
        if (state.hasClient) {
          return callback();
        }
        return lyncManager.startClient(null, function(error) {
          debug('lyncManager.startClient', JSON.stringify({
            error: error
          }, null, 2));
          if (error != null) {
            return callback(error);
          }
          return callback();
        });
      });
    };
  })(this);

  module.exports = {
    autoCheck: autoCheck,
    stopAutoCheck: stopAutoCheck
  };

}).call(this);

//# sourceMappingURL=lync-launcher.js.map
